:... BK_TAPE.BAT, Craig MacPherson
:

@echo off

:... Reset default drive and directory
     cd %D2%\backups
     %D2%

:... Check to see if this file should loop, problem with norton utilities
:    hangs PC if not done this way.
     if %1.==TAPE_CHANGE_LOOP. goto TAPE_CHANGE_LOOP

:... Update the date and time to environment variables.
     echo Updating Backup System Variables
     bebe STATUS ALL

:... Check to see if the %TAPE% variable is set (in case of power outage)
     if %TAPE%.==. call volume.bat

:... If it is not time for a tape change or is a weekend - do nothing
     if not %HOUR%.==7. goto end
     if %DOW%.==SATURDAY. goto end
     if %DOW%.==SUNDAY. goto end


REM Check to see if tape has already been changed
REM if exist %TAPE%.vol goto end

rem ECHO Printing Tape List
rem Tape needs a change so print the tape directory
rem TDIR \/LI:"\backup\tmp.lst"/S/Y/YY
rem copy cur_tape.vol+tmp.lst tape.lst
rem del tmp.lst 
rem copy hpsetup.lst lpt1:
rem print tape.lst


:TAPE_CHANGE_LOOP
:... Automatic request for tape change
     beep 
     send "Tape Mount Request - New Backup Tape" %NOTIFY% >>nul:
     cls
     echo Current tape in use:%TAPE%
     echo A blank tape has been requested for the Backup Server.
     echo.
     echo      L = Load a new Tape
     echo      S = Skip the Tape Change and continue using existing tape
     echo.
     be ASK "Delay for 100 seconds, Or enter Option:", qls DEFAULT=q TIMEOUT=100
     if errorlevel 3 goto SKIP_TAPE_CHANGE
     if errorlevel 2 goto LOAD_TAPE
     %D1%BK_TAPE TAPE_CHANGE_LOOP

:SKIP_TAPE_CHANGE
:... Prevents tape change from being requested again today
     echo Tape Change was skipped >%TAPE%.vol
     goto end

:LOAD_TAPE
:... Request operator to label, load and enter the new tape and volume number
:    program will create a batch file that will set TAPE variable     
     basica loadtape 
     call %D1%volume.bat
     echo.
     echo.
     be ASK "Does this tape require ERASEING? (y/n):", yn DEFAULT=y
     if errorlevel 2 goto UPDATE_VOL
     if errorlevel 1 goto ERASE_TAPE

:ERASE_TAPE
     echo.
     echo.
     echo Erasing Tape
     TENSION /ER

:UPDATE_VOL
:... Update the tape volume files
:    Delete old tape volume check file
     del %D2%\backups\*.vol
     echo Tape change check file >%TAPE%.vol    
     echoplus CR "                         TAPE VOLUME ==> %TAPE%">%D2%\backups\cur_tape.vol

:... Update the backup system activity.log file with tape info
     echo ***************** Tape Change: New Tape =%TAPE%  OP=%OP% **************************>tmp.inp
     copy %D2%\backups\activity.lgs\activity.log + tmp.inp %D2%\backups\activity.lgs\activity.log
     del tmp.inp

:END
:... Run routine to service the queues
     %D1%BK_SRV_Q
