:... S_BACKSV.BAT, Craig MacPherson
: 
:    Batch routine to backup the system file server.
: 
:    Variables passed
:    %1 - ALL or MOD
:    %2 - Drive
:    %3 - Server
:    %4 - Volume

@echo off
cls

:... Map backup drive to correct server and volume
     map %2:=%3/%4:\

     cd \backups\backup.jbs

:... Mark Start of Job message in detailed log
     call %D2%b_soj.bat SRV

:... Which backup to run Mod or Full
     if %1.==. goto ALL_FILES
     if %1.==MOD. goto MODIFIED_FILES_ONLY
     :ALL_FILES  
       set STATUS=GOOD
       tbackup %2:\/s/y/la:"Server Complete backup - %4"/a/li:"files.tmp":a
       if errorlevel set STATUS=BAD
       goto UPDATE_LOGS

    :MODIFIED_FILES_ONLY
       set STATUS=GOOD
       tbackup %2:\/s/y/m/la:"Server Modified files only - %4"/a/li:"files.tmp":a 
       if errorlevel set STATUS=BAD
       goto UPDATE_LOGS


:UPDATE_LOGS
     :USERS_DETAILED_LOG
     :... Add current tape volume to users detailed history log
          copy %D2%\backups\activity.lgs\SRV.his+%D2%\backups\cur_tape.vol %D2%\backups\activity.lgs\SRV.his

     :... Add Maynard tape program output to users detailed history log
          copy %D2%\backups\activity.lgs\SRV.his+files.tmp %D2%\backups\activity.lgs\SRV.his
          del files.tmp>>nul:

     :... Check for skipped or corrupt files, add info to users detailed history log
          call %D1%b_skip.bat SRV
          goto MARK_EOJ

     :MARK_EOJ
     :... Mark EOJ in users history file
          call %D1%b_eoj.bat SRV
 
     :... Strip Form Feeds from users history file
          call %D1%b_strip.bat SRV

     :SYSTEM AND USER SUMMARY LOGS
     :... Add user info and status to system activity log and user summary log
          call %D1%b_activ.bat BACKUP %STATUS% SRV %4 %1 



:END
