{$M $7000,0,0 }
program mail_utility;
uses crt,dos;
(**************************************************************
* BP-LAN Installation Utility         (BPINST.EXE,BPINST.PAS) *
* by Craig Chaiken                                            *
* January 21, 1990                                            *
**************************************************************)
const
	title='Blueprint LAN Version 1.01 Installation Utility 01/21/90';
	minx=1;maxx=80;miny=1;maxy=25;

type	serial_type=record
		base_address:string[8];
		baud_rate_word:word;
		config_byte:byte;
	end;

	drive_type=record
		client_drive:char;
		server_drive:char;
		socket:string[8];
		write_protect_flag:byte
	end;

var
	menu_level,keytemp,savekey,message_num,num_messages,
	transcript_window_x,transcript_window_y,
	help_window_x, help_window_y,
	question_window_x,question_window_y:integer;
	infilevar,outfilevar,transcript:text;
	ch,sourcedrive,bootdrive:char;
	bpdir,bpmaildir,bpuser,bpeditor:string[255];
	dirinfo:searchrec;
	num_sockets,num_drives:byte;
	last_drive:char;
	serial:array[0..255] of serial_type;
	drive:array[1..24] of drive_type;

procedure exit_to_dos;
var regs:registers;
begin
	regs.ax:=$4c00;
	msdos(regs)
end;

procedure delete_file(filename:string);
begin
     exec(getenv('COMSPEC'),'/c del '+filename+' > nul');
end;

procedure copy_file(filename1,filename2:string);
begin
     exec(getenv('COMSPEC'),'/c copy '+filename1+' '+filename2+' > nul');
end;

function starts_with(line:string;s:string):boolean;
begin
	starts_with:=(copy(line,1,length(s))=s);
end;

function keyval:integer;
var
	temp:integer;
begin
	if savekey<>0 then
     begin
     	savekey:=0;
          temp:=keytemp
     end
     else
     begin
     	temp:=ord(readkey);
          if temp=0 then
          temp:=ord(readkey) shl 8
     end;
     keyval:=temp
end;

function charloc(line:string;start:integer;findchar:char):integer;
var
	s:string;
begin
	s:=copy(line,start,length(line));
     charloc:=pos(findchar,s)+start-1
end;

procedure reverse_write(message:string);
var
	i:integer;
begin
	i:=textattr;
     textattr:=(i and $80) or ((i and $70) shr 4) or ((i and $7) shl 4);
     write(message);
     textattr:=i;
end;

function get_choice(message:string;choices:string):char;
var
	c:char;
begin
	c:=chr(255);
     while ((c<>choices[1]) and (c<>choices[2]) and
     	(c<>choices[3]) and (c<>choices[4]) and
          (c<>choices[5]) and (c<>choices[6])) do
          begin
          	write(message);
               c:=readkey;
               writeln(' ',c)
          end;
     get_choice:=c
end;

procedure box(x1,y1,x2,y2:integer;top,bottom:string);
var
	i,x1a,y1a,x2a,y2a,topoffset,bottomoffset:integer;
     clipx,clipy:boolean;
begin
	clipx:=false;
     clipy:=false;
     x1a:=x1;x2a:=x2;
     y1a:=y1;y2a:=y2;
     if (x1a<minx) then
     begin
     	clipx:=true;
          x1a:=minx
     end;
     if (x2a>maxx) then
     begin
     	clipx:=true;
          x2a:=maxx
     end;
     if (y1a<miny) then
     begin
     	clipy:=true;
          y1a:=miny
     end;
     if (y2a>maxy) then
     begin
     	clipy:=true;
          y2a:=maxy
     end;
     window(minx,miny,maxx,maxy);
     assigncrt(input);reset(input);
     assigncrt(output);rewrite(output);
     if not clipy then
     for i:=x1a to x2a do
     begin
     	gotoxy(i,y1a);write(chr(219));
          gotoxy(i,y2a);write(chr(219))
     end;
     if not clipx then
     for i:=y1a to y2a do
     begin
     	gotoxy(x1a,i);write(chr(219));
          gotoxy(x2a,i);write(chr(219))
     end;
     topoffset:=((x2a-x1a-length(top)) shr 1);
     bottomoffset:=((x2a-x1a-length(bottom)) shr 1);
     for i:=1 to length(top) do
     begin
     	gotoxy(x1a+i-1+topoffset,y1a);reverse_write(top[i]);
     end;
     for i:=1 to length(bottom) do
     begin
     	gotoxy(x1a+i-1+bottomoffset,y2a);reverse_write(bottom[i]);
     end;
     window(x1+1,y1+1,x2-1,y2-1);
     clrscr;
end;


procedure open_transcript;
begin
	box(1,1,80,13,title,'INSTALLATION TRANSCRIPT');
	transcript_window_x:=wherex;
	transcript_window_y:=wherey;
end;

procedure open_help(s:string);
begin
	box(1,15,80,18,s,'HELP WINDOW');
	help_window_x:=wherex;
	help_window_y:=wherey;
end;

procedure open_question;
begin
	box(1,20,80,22,'Please Answer the Following Question:',
		'INSTALLATION QUESTIONS');
	question_window_x:=wherex;
	question_window_y:=wherey;
end;

procedure write_question(s:string);
begin
	highvideo;
	window(2,21,79,21);
	gotoxy(question_window_x,question_window_y);
	write(s);
	lowvideo;
end;

procedure writeln_transcript(s:string);
begin
	window(2,2,79,10);
	gotoxy(transcript_window_x,transcript_window_y);
	writeln(s);
	if paramstr(1)<>'' then
          writeln(transcript,s);
	transcript_window_x:=wherex;transcript_window_y:=wherey
end;

procedure writeln_help(s:string);
begin
	window(2,16,79,18);
	gotoxy(help_window_x,help_window_y);
	writeln(s);
	help_window_x:=wherex;help_window_y:=wherey
end;

procedure install;
var
	i:integer;
	outfilevar:text;
begin
	open_help('Installing BP-LAN...');
	open_transcript;
	writeln_transcript('Creating BP-LAN Directory: '+bpdir);
	{$I-}
	mkdir(bpdir);
	{$I+}
	if ioresult<>0 then
	writeln_transcript('Directory ('+bpdir+') Already Exists');
	writeln_transcript('Copying BP-LAN Files from '+sourcedrive+': to '+
		bpdir);
	copy_file(sourcedrive+':\bp*.*',bpdir);
	writeln_transcript(
'Saving Unmodified CONFIG.SYS and AUTOEXEC.BAT files to '+bpdir);
	copy_file(bootdrive+':\autoexec.bat ',bpdir+'\*.old');
	copy_file(bootdrive+':\config.sys',bpdir+'\*.old');
	writeln_transcript('Creating BP-LAN Startup Batch File: '+
		bpdir+'\bprun.bat');
	assign(outfilevar,bpdir+'\bprun.bat');
	rewrite(outfilevar);
	writeln(outfilevar,'set bpdir=',bpdir);
	writeln(outfilevar,'set bpuser=',bpuser);
	writeln(outfilevar,'set bpmaildir=',bpmaildir);
	writeln(outfilevar,'set bpeditor=',bpeditor);
	writeln(outfilevar,'path=%path%;%bpdir%');
	writeln(outfilevar,'bpbios');
	for i:=0 to num_sockets-1 do
	begin
		writeln(outfilevar,'bpserial /$',serial[i].base_address,' /3 /',
			serial[i].baud_rate_word);
	end;
	close(outfilevar);
	assign(outfilevar,bootdrive+':\autoexec.bat');
	append(outfilevar);
	writeln(outfilevar,bpdir,'\bprun.bat');
	close(outfilevar);
	assign(outfilevar,bootdrive+':\config.sys');
	append(outfilevar);
	writeln(outfilevar,'shell=',getenv('COMSPEC'),' /p /e:999');
	for i:=1 to num_drives do
	begin
		writeln(outfilevar,'device=',bpdir,'\bpmount.sys /',drive[i].server_drive,' /',
			drive[i].socket);
	end;
	close(outfilevar);
	writeln_help('Reboot this machine to activate BP-LAN Software.');
end;

procedure install_info;
begin
	open_help('Source Drive');
	writeln_help(
'The Source Drive refers to the letter of the drive (usually A: or B:) which');
	writeln_help(
'contains the BP-LAN version 1.00 Software, and installation program.');
     write_question('Enter Letter Source Drive: ');
     readln(sourcedrive);
	writeln_transcript('Source Drive = '+upcase(sourcedrive)+':');
	open_help('Boot Drive');
	writeln_help(
'The Boot Drive refers to the letter of the drive (usually A: or C:) which');
	writeln_help(
'contains the CONFIG.SYS and AUTOEXEC.BAT files to be modified.');
     write_question('Enter Letter Boot Drive: ');
     readln(bootdrive);
	writeln_transcript('Boot Drive = '+upcase(bootdrive)+':');
	open_help('Destination Directory');
	writeln_help(
'The Destination Directory refers to the Directory on the Local PC, where');
	writeln_help(
'BP-LAN files are to be copied (example, C:\BP-LAN).');
	write_question('Enter BP-LAN Destination Directory: ');
	readln(bpdir);
	writeln_transcript('Destination Directory = '+bpdir);
	open_help('Verify Answers');
	writeln_help(
'Press Y if the information in the transcript window is correct.');
	writeln_help(
'Press N if not correct.  Press E to Exit Installation Utility.');
	write_question('');
	highvideo;
	ch:=get_choice('Are the above answers correct? (Y/N/E) ','YyNnEe');
	lowvideo;
	if (ch='N') or (ch='n') then
          install_info
	else
	if (ch='E') or (ch='e') then
		exit_to_dos
end;

procedure mail_info;
begin
	open_help('Electronic Mail Directory');
	writeln_help(
'The Electronic Mail Directory refers to the directory on the server');
	writeln_help(
'where shared mail messages are to be stored (example, D:\MAIL).');
	write_question('Enter BP-LAN Electronic Mail Directory: ');
	readln(bpmaildir);
	writeln_transcript('BP-LAN Electronic Mail Directory = '+bpmaildir);
	open_help('Default Text Editor');
	writeln_help(
'The Default Text Editor refers to the path of the editor with which the user');
	writeln_help(
'will create outgoing electronic mail messages (example, C:\BRIEF\B.EXE).');
	write_question('Enter Path of BP-LAN Default Text Editor: ');
	readln(bpeditor);
	writeln_transcript('BP-LAN Default Text Editor = '+bpeditor);
	open_help('Username');
	writeln_help(
'The Username refers to the 8 character, or less name which will uniquely');
	writeln_help(
'identify the user of the machine (example, MSMITH).');
	write_question('Enter Username (8 characters or less): ');
	readln(bpuser);
	writeln_transcript('Username = '+bpuser);
	open_help('Verify Answers');
	writeln_help(
'Press Y if the information in the transcript window is correct.');
	writeln_help(
'Press N if not correct.  Press E to Exit Installation Utility.');
	write_question('');
	highvideo;
	ch:=get_choice('Are the above answers correct? (Y/N/E) ','YyNnEe');
	lowvideo;
	if (ch='N') or (ch='n') then
          mail_info
	else
	if (ch='E') or (ch='e') then
		exit_to_dos
end;

procedure serial_info;
var	s,s2:string;baud_rate:longint;i:integer;
begin
	open_help('Network Sockets');
	writeln_help(
'The Number of Network Sockets refers the number of RS232C serial ports');
	writeln_help(
'that you wish to connect to other network nodes (clients and servers).');
	write_question('Enter the Number of BP-LAN Network Sockets: ');
	readln(num_sockets);
	str(num_sockets,s);
	writeln_transcript('Number of BP-LAN Network Sockets = '+s);
	for i:=0 to num_sockets-1 do
	begin
	open_help('Serial Port Base Address');
writeln_help(
'Base Address refers to the hexadecimal number of the lowest');
writeln_help(
'I/O address used by this RS232C Port.  For example, COM1=3F8 and COM2=2F8');
	str(i,s);
	write_question('Enter the Base Address for Socket '+s+': ');
	readln(s2);serial[i].base_address:=s2;
	writeln_transcript('Base Address for Socket '+s+' = '+s2);
	open_help('Serial Port Baud Rate');
writeln_help(
'Baud Rate refers to the data transmission speed.  Slow (4.77 Mhz) computers');
writeln_help(
'can transmit at 57600 baud.  Faster computers may transmit at 115200 baud');
	write_question('Enter Baud Rate: ');
	readln(baud_rate);
	serial[i].baud_rate_word:=115200 div baud_rate;
	str(baud_rate,s);
	writeln_transcript('Baud Rate = '+s);
	end;
	open_help('Verify Answers');
	writeln_help(
'Press Y if the information in the transcript window is correct.');
	writeln_help(
'Press N if not correct.  Press E to Exit Installation Utility.');
	write_question('');
	highvideo;
	ch:=get_choice('Are the above answers correct? (Y/N/E) ','YyNnEe');
	lowvideo;
	if (ch='N') or (ch='n') then
          serial_info;
end;

procedure drive_info;
var	s:string;i:integer;
begin
	open_help('Network Drives');
	writeln_help(
'The Number of Network Drives refers the number of shared network drives');
	writeln_help(
'that you wish to make available to this client.');
	write_question('Enter the Number of BP-LAN Network Drives: ');
	readln(num_drives);
	str(num_drives,s);
	writeln_transcript('Number of BP-LAN Network Drives = '+s);
	if num_drives<>0 then
	begin
		open_help('Last Non-Network Drive');
		writeln_help(
'The Last Non-Network Drive refers to the letter of the last drive prior to');
		writeln_help(
'installing BP-LAN.  Example: B for a floppy machine, C for hard drive.');
		write_question('Enter the Letter of the Last Non-Network Drive: ');
		readln(s);
		last_drive:=upcase(s[1]);
		writeln_transcript('The Last Non-Networked Drive on this client = '+
			last_drive+':');
	for i:=1 to num_drives do
	begin
	open_help('Shared Drive '+chr(ord(last_drive)+i)+': Socket');
writeln_help(
'Shared Drive Socket refers to the number of the socket connected to the');
writeln_help(
'server for this drive.');
	str(i,s);
	write_question('Enter the Socket Number of the server of client drive '+
		chr(ord(last_drive)+i)+': ');
	readln(s);drive[i].socket:=s;
	writeln_transcript('Server with Drive '+chr(ord(last_drive)+i)+': is '+
		'connected via socket '+s);
	open_help('Server Drive Letter');
writeln_help(
'Server Drive Letter refers to the letter of the drive on the server that');
writeln_help(
'you wish to mount as drive '+chr(ord(last_drive)+i)+': on this client');
	write_question('Enter Server Drive Letter: ');
	readln(s);
	drive[i].server_drive:=upcase(s[1]);
	writeln_transcript('Mounting Server Drive '+upcase(s[1])+': as Client Drive '+
		chr(ord(last_drive)+i)+':');
	end;
	end;
	open_help('Verify Answers');
	writeln_help(
'Press Y if the information in the transcript window is correct.');
	writeln_help(
'Press N if not correct.  Press E to Exit Installation Utility.');
	write_question('');
	highvideo;
	ch:=get_choice('Are the above answers correct? (Y/N/E) ','YyNnEe');
	lowvideo;
	if (ch='N') or (ch='n') then
          drive_info;
end;

begin
	clrscr;
	if paramstr(1)<>'' then
	begin
		assign(transcript,paramstr(1));
          rewrite(transcript);
	end;
	open_transcript;
	open_question;
	open_help('');
	install_info;
	open_transcript;
	serial_info;
	open_transcript;
	drive_info;
	open_transcript;
	mail_info;
	open_transcript;
	install;
	write_question('Press <Return> to Exit to DOS');
	if paramstr(1)<>'' then
	begin
		writeln(transcript,chr(12));
          close(transcript)
	end;
	readln;
     window(minx,miny,maxx,maxy);
     clrscr
end.
