{$M $7000,0,0 }
program mail_utility;
uses crt,dos;
(**************************************************************
* BP-LAN Mail System                  (BPMAIL.EXE,BPMAIL.PAS) *
* by Craig Chaiken                                            *
* October 3, 1989                                             *
**************************************************************)
const
	title='Blueprint LAN MAIL FACILITY 10/03/89';
	minx=1;maxx=80;miny=1;maxy=25;
	max_messages=100;
	name_length=9;
	line_length=90;
	savefile='mbox';
	mailfile='mailfile.tmp';
     editfile='editfile.tmp';
	savemail='savemail.tmp';
	printer='LPT1';

type
	mailrec=
		record
			startpos:longint;
			endpos:longint;
			from:string[line_length];
			cc:string[line_length];
			to_:string[line_length];
			subject:string[line_length];
			date:string[line_length];
			return_path:string[line_length];
			save,delete:boolean
		end;

var
	mail:array[1..max_messages+1] of mailrec;
	start_of_line,end_of_line:longint;
	menu_level,keytemp,savekey,message_num,num_messages:integer;
	line:string[line_length];
	username:string[name_length];
	in_message,mail_processed,mail_modified:boolean;
	infilevar,outfilevar:file;
	ch:char;
	editor,maildir,comspec,homedir,netdir:string;

function whoami:string;
var s:string;
begin
	maildir:=getenv('BPMAILDIR');
	if maildir='' then
	begin
		write('BP-LAN Mail Directory: ');
		readln(maildir);
	end;
	maildir:=maildir+'\';

	editor:=getenv('BPEDITOR');
	if editor='' then
	begin
		write('BP-LAN Text Editor: ');
		readln(editor);
	end;

	comspec:=getenv('COMSPEC');
	if comspec='' then
	begin
		write('COMMAND.COM Path: ');
		readln(comspec);
	end;
     comspec:=comspec;

	netdir:=getenv('BPDIR');
	if netdir='' then
	begin
		write('BP-LAN Directory: ');
		readln(netdir);
	end;
	netdir:=netdir+'\';
	homedir:=netdir;


     username:=getenv('BPUSER');
	if username='' then
	begin
		write('Username: ');
		readln(username);
	end;
	whoami:=username;
end;

function starts_with(line:string;s:string):boolean;
begin
	starts_with:=(copy(line,1,length(s))=s);
end;

function keyval:integer;
var
	temp:integer;
begin
	if savekey<>0 then
	begin
		savekey:=0;
		temp:=keytemp
	end
	else
	begin
		temp:=ord(readkey);
		if temp=0 then
			temp:=ord(readkey) shl 8
	end;
	keyval:=temp
end;

function charloc(line:string;start:integer;findchar:char):integer;
var
	s:string[line_length];
begin
	s:=copy(line,start,length(line));
	charloc:=pos(findchar,s)+start-1
end;


procedure delete_file(filename:string);
begin
     exec(comspec,'/c del '+filename+' > nul');
end;


function date_string:string;
var
	s1,s2:string;
	year,month,day,dayofweek,
	hour,minute,second,sec100:word;
begin
	getdate(year,month,day,dayofweek);
	gettime(hour,minute,second,sec100);
	s1:='';
	str(month,s2);if length(s2)=1 then s2:='0'+s2;s1:=s1+s2+'/';
	str(day,s2);if length(s2)=1 then s2:='0'+s2;s1:=s1+s2+'/';
	str(year,s2);if length(s2)=1 then s2:='0'+s2;s1:=s1+s2+'  ';
	str(hour,s2);if length(s2)=1 then s2:='0'+s2;s1:=s1+s2+':';
	str(minute,s2);if length(s2)=1 then s2:='0'+s2;s1:=s1+s2;
	date_string:=s1
end;


procedure reverse_write(message:string);
var
	i:integer;
begin
	i:=textattr;
	textattr:=(i and $80) or ((i and $70) shr 4) or ((i and $7) shl 4);
	write(message);
	textattr:=i;
end;

function get_choice(message:string;choices:string):char;
var
	c:char;
begin
	c:=chr(255);
	while ((c<>choices[1]) and (c<>choices[2]) and
		(c<>choices[3]) and (c<>choices[4]) and
		(c<>choices[5]) and (c<>choices[6])) do
		begin
			write(message);
			c:=readkey;
			writeln(' ',c)
		end;
	get_choice:=c
end;

procedure box(x1,y1,x2,y2:integer;top,bottom:string);
var
	i,x1a,y1a,x2a,y2a,topoffset,bottomoffset:integer;
	clipx,clipy:boolean;
begin
	clipx:=false;
	clipy:=false;
	x1a:=x1;x2a:=x2;
	y1a:=y1;y2a:=y2;
	if (x1a<minx) then
		begin
			clipx:=true;
			x1a:=minx
		end;
	if (x2a>maxx) then
		begin
			clipx:=true;
			x2a:=maxx
		end;
	if (y1a<miny) then
		begin
			clipy:=true;
			y1a:=miny
		end;
	if (y2a>maxy) then
		begin
			clipy:=true;
			y2a:=maxy
		end;
	window(minx,miny,maxx,maxy);
	assigncrt(input);reset(input);
	assigncrt(output);rewrite(output);
	if not clipy then
	for i:=x1a to x2a do
		begin
			gotoxy(i,y1a);write(chr(219));
			gotoxy(i,y2a);write(chr(219))
		end;
	if not clipx then
	for i:=y1a to y2a do
		begin
			gotoxy(x1a,i);write(chr(219));
			gotoxy(x2a,i);write(chr(219))
		end;
	topoffset:=((x2a-x1a-length(top)) shr 1);
	bottomoffset:=((x2a-x1a-length(bottom)) shr 1);
	for i:=1 to length(top) do
		begin
			gotoxy(x1a+i-1+topoffset,y1a);reverse_write(top[i]);
		end;
	for i:=1 to length(bottom) do
		begin
			gotoxy(x1a+i-1+bottomoffset,y2a);reverse_write(bottom[i]);
		end;
	window(x1+1,y1+1,x2-1,y2-1);
	clrscr;
end;

procedure unix_readln;
var
	i,num_read:integer;
	c:char;
begin
	i:=0;
	num_read:=1;
	c:=' ';
	while (num_read=1) and (c<>chr(10)) and (i<line_length-3) do
		begin
			blockread(infilevar,c,1,num_read);
			if num_read<>0 then
			case ord(c) of
				9:
					begin
						if (i and 7)=0 then
						begin
							inc(i);
							line[i]:=' '
						end;
						while (i and 7)<>0 do
						begin
							inc(i);
							line[i]:=' '
						end;
					end;
				13:
					begin
						inc(i);
						line[i]:=c;
						inc(i);
						line[i]:=chr(10)
					end;
				32..255:
					begin
						inc(i);
						line[i]:=c
					end
			end
		end;
	line[0]:=chr(255 and i);
end;

procedure get_header(i:integer);
begin
	if starts_with(line,'From ') then
		begin
			mail[i+1].return_path:=copy(line,6,charloc(line,6,chr(13))-6);
			in_message:=true;
			inc(message_num);
			if i>0 then
				mail[i].endpos:=start_of_line-2;
          	mail[i+1].from:=copy(line,6,charloc(line,6,chr(13))-6);
			mail[i+1].cc:=chr(0);
			mail[i+1].to_:=chr(0);
			mail[i+1].subject:=chr(0);
			mail[i+1].date:=chr(0);
			mail[i+1].delete:=false;
			mail[i+1].save:=false
		end
	else
	if starts_with(line,'Date:') then
          mail[i].date:=copy(line,7,charloc(line,7,chr(13))-7)
	else
	if starts_with(line,'To:') then
          mail[i].to_:=copy(line,5,charloc(line,5,chr(13))-5)
	else
	if starts_with(line,'Cc:') then
          mail[i].cc:=copy(line,5,charloc(line,5,chr(13))-5)
	else
	if starts_with(line,'Subject:') then
		mail[i].subject:=copy(line,10,charloc(line,10,chr(13))-10)
	else
	if starts_with(line,'Return-Path:') then
		mail[i].return_path:=copy(line,15,charloc(line,15,'>')-15)
end;

procedure process;
var
	s:string[line_length];
	linepos:integer;
begin
	mail_processed:=true;
	num_messages:=0;
	if paramstr(1)='' then
		assign(infilevar,maildir+username)
	else
		assign(infilevar,paramstr(1));
	{$I-}
	reset(infilevar,1);
	{$I+}
	if (ioresult<>0) or (filesize(infilevar)=0) then
	begin
		rewrite(infilevar,1);
		highvideo;
		writeln('No Mail for ',username);
		writeln('Press <RETURN> to Continue');
		readln;
		lowvideo
	end
	else
	begin
		highvideo;
		write('Processing Mail File');
		in_message:=false;
		message_num:=0;
		mail[1].subject[0]:=chr(0);
		mail[1].date[0]:=chr(0);
		mail[1].return_path[0]:=chr(0);
		start_of_line:=filepos(infilevar);
		unix_readln;
		end_of_line:=filepos(infilevar);
		while line[0]<>chr(0) do
		begin
			write('.');
			get_header(message_num);
			if (in_message and (line[0]=chr(2))) then
				begin
					in_message:=false;
					if message_num>0 then
						mail[message_num].startpos:=end_of_line;
				end;
			start_of_line:=filepos(infilevar);
			unix_readln;
			end_of_line:=filepos(infilevar);
		end;
		num_messages:=message_num;
		mail[num_messages].endpos:=start_of_line-1;
		lowvideo
	end;
end;

procedure headers(i:integer);
begin
	box(1,1,80,7,title+' - VIEW MESSAGE','');
	if i<=num_messages then
		writeln('Message     : ',i,' of ',num_messages)
	else
		writeln('SEND MESSAGE');
	if i>num_messages then
		writeln('To          : ',mail[i].return_path);
	if i<=num_messages then
		writeln('From        : ',mail[i].from);
	writeln('Subject     : ',mail[i].subject);
	if i<=num_messages then
		writeln('Date        : ',mail[i].date);
	if i<=num_messages then
       	write('Distribution: ',mail[i].to_,' ',mail[i].cc)
end;

procedure body(i:integer);
const
	lines_per_screen=16;
var
	startpos,endpos:longint;
	s:string[line_length];
	linenum:integer;
begin
	box(0,7,81,24,'MESSAGE BODY',
chr(24)+'-Prev  '+chr(25)+'-Next  D-Del  F-File'+
'  P-Print  R-Reply  T-Top  U-Undel  Q-Quit');
	startpos:=mail[i].startpos;
	endpos:=mail[i].endpos;
	linenum:=0;
	seek(infilevar,startpos);
	if not mail[i].delete then
	begin
	mail[i].save:=true;
	while (filepos(infilevar)<endpos) do
		begin
			inc(linenum);
			if linenum>=lines_per_screen then
				begin
					highvideo;
					write
					('**********Press <SPACE> for More**********');
					lowvideo;
					keytemp:=keyval;
					writeln;
					if (keytemp=ord(' ')) then
						begin
							clrscr;
							linenum:=1
						end
					else
					begin
						seek(infilevar,endpos);
						savekey:=keytemp
					end;
				end;
			unix_readln;
			write(line);
			if ord(line[0])>79 then
				inc(linenum);
		end
		end
	else
		begin
			clrscr;
			highvideo;
			writeln('This Message has been Tagged for Deletion!');
			writeln;
			lowvideo
		end;
	highvideo;
	write('**********End of Message**********');
	lowvideo;
end;

procedure delete (message_num:integer);
begin
	mail_modified:=true;
	mail[message_num].delete:=true;
	clrscr;
	highvideo;
	writeln('Message #',message_num,
		' has been Tagged for Deletion');
	lowvideo
end;

procedure undelete (message_num:integer);
begin
	mail[message_num].delete:=false;
	clrscr;
	headers(message_num);
	body(message_num);
end;

procedure write_message(message_num:integer);
var
	num_read:integer;
	i,headerpos:longint;
	buffer:array[1..20000] of char;
begin
	headerpos:=0;
	if message_num>1 then
		headerpos:=mail[message_num-1].endpos+1;
	seek(infilevar,headerpos);
     i:=mail[message_num].endpos-(headerpos-1);
	blockread(infilevar,buffer,i,num_read);
	blockwrite(outfilevar,buffer,num_read);
	write('.')
end;

procedure file1 (message_num:integer);
var
	tempfilevar:text;
	filename:string[line_length];
	startpos,endpos:longint;
begin
	clrscr;
	highvideo;
	if (keytemp=ord('p')) or (keytemp=ord('P')) then
		begin
			write('Printing Message #',message_num,' to ',printer);
			filename:=printer
		end
	else
		begin
			write('Save Message #',message_num,' to Which Filename? ');
			readln(filename)
		end;
	assign(tempfilevar,filename);
	rewrite(tempfilevar);
	startpos:=mail[message_num].startpos;
	endpos:=mail[message_num].endpos;
	seek(infilevar,startpos);
	if (keytemp=ord('p')) or (keytemp=ord('P')) then
		write('')
	else
		write('Saving Message #',message_num,' to ',filename);
	writeln(tempfilevar,'Message     : ',message_num,' of ',num_messages);
	writeln(tempfilevar,'From        : ',mail[message_num].from);
	writeln(tempfilevar,'Subject     : ',mail[message_num].subject);
	writeln(tempfilevar,'Date        : ',mail[message_num].date);
	writeln(tempfilevar,'Return-Path : ',mail[message_num].return_path);
	writeln(tempfilevar,'Distribution: ',mail[message_num].to_,' ',
		mail[message_num].cc);
	writeln(tempfilevar);
	while (filepos(infilevar)<endpos) do
		begin
			unix_readln;
			write('.');
			write(tempfilevar,line)
		end;
	if (keytemp=ord('p')) or (keytemp=ord('P')) then
		write(tempfilevar,chr(12));
	close(tempfilevar);
	writeln;
	if (keytemp=ord('p')) or (keytemp=ord('P')) then
		writeln('Print Completed!')
	else
		writeln('Save Completed!');
	lowvideo
end;

procedure save(message_num:integer);
begin
     {$I-}
     assign(outfilevar,homedir+savefile);
     reset(outfilevar,1);
     {$I+}
     if ioresult<>0 then
          rewrite(outfilevar,1);
	seek(outfilevar,filesize(outfilevar));
	write_message(message_num);
	close(outfilevar);
end;

procedure update;
var
	i:integer;
begin
	clrscr;
	highvideo;
     begin
     	{$I-}
         	assign(outfilevar,homedir+savefile);
	     reset(outfilevar,1);
	     {$I+}
	     if ioresult<>0 then
               rewrite(outfilevar,1);
          write('Appending Undeleted Message to ',homedir+savefile);
	     for i:=1 to num_messages do
		     if (not(mail[i].delete)) and (mail[i].save) then
			     save(i);
          writeln
     end;
	if mail_processed then
	begin
		assign(outfilevar,homedir+mailfile);
		rewrite(outfilevar);
		write('Updating Mail File');
		for i:=1 to num_messages do
			if (not mail[i].delete) and (not mail[i].save) then
				write_message(i);
		writeln;
		close(outfilevar);
		if paramstr(1)='' then
			exec(comspec,'/c copy /b'+homedir+mailfile+' '+
				maildir+username+'> nul')
		else
		exec(comspec,'/c copy /b'+homedir+mailfile+' '+
			paramstr(1)+'> nul');
		if doserror=0 then
			delete_file(homedir+mailfile);
	end;
	lowvideo
end;

procedure edit;
var
	i:integer;
	filename:string[line_length];
	c:char;
begin
	box(0,7,81,24,title+' - SEND MESSAGE','');
	c:=get_choice('Originate Message from Keyboard, Editor or File (K/E/F)?',
     'KkEeFf');
     case c of
     'K','k':
	begin
		c:=chr(10);
		assign(outfilevar,homedir+mailfile);
		rewrite(outfilevar,1);
		box(0,7,81,24,title+' - EDIT MESSAGE',
			'Type a ''.'' and <RETURN> Alone on a Line to Terminate Message');
		clrscr;
		readln(line);
		while (line[0]<>chr(1)) or (line[1]<>'.') do
			begin
               	blockwrite(outfilevar,line[1],length(line));
				c:=chr(13);
				blockwrite(outfilevar,c,1);
				c:=chr(10);
				blockwrite(outfilevar,c,1);
				readln(line);
			end;
		close(outfilevar);
	end;
     'E','e':
     begin
          exec(editor,homedir+mailfile);
          clrscr;
          if menu_level=1 then
             headers(max_messages+1)
          else
              headers(message_num);
          box(0,7,81,24,title+' - SEND MESSAGE','');
     end;
     'F','f':
	begin
		write('Enter Filename of Message: ');
		readln(filename);
		exec(comspec,'/c copy '+filename+' '+
		homedir+mailfile+' > nul');
	end
end
end;

procedure reply (i:integer);
var
	c:char;
	outfilevar:text;
begin
	edit;
	highvideo;
	c:=get_choice('Do You Really Want to Send This Message (Y/N)?','YyNn');
	if (c='Y') or (c='y') then
	begin
		writeln('Sending Message...');
     	{$I-}
         	assign(outfilevar,maildir+mail[i].return_path);
	     append(outfilevar);
	     {$I+}
	     if ioresult<>0 then
               rewrite(outfilevar);

		writeln(outfilevar,'From ',username);
		writeln(outfilevar,'To: ',mail[i].return_path);
		writeln(outfilevar,'Subject: ',mail[i].subject);
		writeln(outfilevar,'Date: ',date_string);
		writeln(outfilevar);
		close(outfilevar);
		exec(comspec,'/c type '+homedir+
		mailfile+'>> '+maildir+mail[i].return_path);
		if doserror<>0 then
			writeln('DOS Error = ',doserror)
     end
	else
		writeln('Message Aborted by User');
	assign(outfilevar,homedir+mailfile);
	erase(outfilevar);
	writeln('Press <RETURN> to Continue');
     lowvideo;
     readln;
     if menu_level=1 then
     begin
	     headers(max_messages+1);
	     body(max_messages+1)
     end
end;

procedure send;
begin
	box(12,8,68,17,title+' - SEND MESSAGE','');
	highvideo;
	mail[max_messages+1].from:=username;
	mail[max_messages+1].date:='Today';
	write('To: ');
	readln(mail[max_messages+1].return_path);
	write('Subject: ');
	readln(mail[max_messages+1].subject);
	lowvideo;
     mail[max_messages+1].save:=false;
     mail[max_messages+1].delete:=false;
	headers(max_messages+1);
	reply(max_messages+1);
end;

procedure view;
begin
	clrscr;
	message_num:=1;
	headers(message_num);
	body(message_num);
	keytemp:=keyval;
	while (keytemp<>ord('q')) and (keytemp<>ord('Q')) do
	begin
		case keytemp of
		$4800:{Up-Arrow}
		begin
			if message_num>1 then
				begin
					dec(message_num);
					headers(message_num);
					body(message_num);
				end;
		end;
		$5000:{Down-Arrow}
		begin
			if message_num<num_messages then
				begin
					inc(message_num);
					headers(message_num);
					body(message_num);
				end;
		end;
		68,100:{D or d}
			delete(message_num);
		70,102,80,112:{F,f,P, or p}
			file1(message_num);
		82,114:{R or r}
               begin
			     reply(message_num);
                    headers(message_num);
                    body(message_num);
               end;
		84,116:{T or t}
			begin
				headers(message_num);
				body(message_num)
			end;
		85,117:{U or u}
			undelete(message_num);
	end;
	keytemp:=keyval;
	end;
	window(minx,miny,maxx,maxy);
	clrscr;
end;

begin
	clrscr;
     menu_level:=0;
	mail_processed:=false;
	mail_modified:=false;
	keytemp:=0;savekey:=0;
	num_messages:=0;
	username:=whoami;
	box(12,8,68,17,title+' - INITIALIZATION',
		'Please Wait');
	process;
	while (keytemp<>ord('q')) and (keytemp<>ord('Q'))
		and (keytemp<>ord('x')) and (keytemp<>ord('X')) do
	begin
		if (keytemp=ord('s')) or (keytemp=ord('S')) then
			begin
                    menu_level:=1;
				send;
				window(minx,miny,maxx,maxy);
				clrscr;
                    menu_level:=0
			end
		else
		if (keytemp=ord('v')) or (keytemp=ord('V')) then
			if num_messages>0 then
				view;
		box(12,8,68,17,title+' - MAIN MENU',
		'Please Select an Option');
		writeln(' Q - Quit Mail Facility and Update Mail File');
		writeln;
		writeln(' S - Send a Mail Message or File');
		writeln;
		writeln(' V - View Mail Messages (Messages Waiting = ',
				num_messages,')');
		writeln;
		writeln(' X - Exit Mail Facility without Updating Mail File');
		keytemp:=keyval;
	end;
	if (keytemp=ord('q')) or (keytemp=ord('Q')) then
		update;
	window(minx,miny,maxx,maxy);
	clrscr
end.
