page 60,132
title   BP-LAN Server Operating System
;*************************************************************
;* BP-LAN Server Operating System(BPSERVER.ASM, BPSERVER.COM)*
;* by Craig Chaiken                                          *
;* September 21 1989                                        *
;* Function:                                                 *
;*     Services All Requests for Access to Shared Resources. *
;* Command Format:                                           *
;*     BPSERVER /buffer_size /background_flag                *
;*************************************************************

codeseg segment byte
        assume  cs:codeseg,ds:codeseg,es:codeseg
        org     100h

init    proc    near            ;*** Initialize All Nodes ***
        mov     al,cs:[80h]
        or      al,al
        jz      default
        mov     si,81h
        call    get_opt ;get buffer_length from command line
        jb      default
        mov     buffer_length,cx
        call    get_opt ;get background_flag from command line
        mov     background,cl
        cmp     cl,0
        jz      default
        call    intinst
default: call    cls
        lea     di,banner       ;display opening banner
        call    messout
        jmp     poll
init    endp

        include bpbioshd.mod
        include misc.mod
        include console.mod

        include fileserv.mod            ;Remote File Sharing
        include child.mod               ;Remote Command Execution
        include lowlevel.mod            ;Remote Lowlevel Command Execution
        include prinserv.mod            ;Remote Printer Sharing
        include semaphor.mod            ;Semaphore Handling

process_packet  proc    near    ;*** Process Packet ***
        call    fileser         ;entry to FILESERV.MOD
        call    comman          ;entry to CHILD.MOD
        call    lowlev          ;entry to LOWLEVEL.MOD
        call    prinser         ;entry to PRINSERV.MOD
        call    semaph          ;entry to SEMAPHOR.MOD
        ret
process_packet  endp

poll    proc    near            ;*** Poll All Nodes for Packet Headers ***
        mov     socket_num,0
poll1:  call    packet
        inc     socket_num
        bpbios  ctrl_int,get_nodes
        cmp     al,socket_num
        jg      poll1
        jmp     poll
poll    endp

packet  proc    near            ;*** Process Packet ***
        mov     ax,ss           ;save stack info
        mov     cs:sslocal,ax
        mov     ax,sp
        mov     cs:splocal,ax
        cli                     ;switch to local stack
        mov     ax,cs
        mov     ss,ax
        mov     ax,offset cs:sflocal
        mov     sp,ax
        sti
        call    escape          ;exit if <ESC> key is pressed
        bpbios  phys_int,receive_status,socket_num
        jnz     packe1
        jmp     packe3
packe1: bpbios  phys_int,receive_byte,socket_num
        cmp     al,soh          ;read block if start of header received
        jz      packe2
        jmp     packe3
packe2: get_packet      socket_num,packet_length,offset packet_buffer
        call    process_packet
packe3: cli                     ;restore old stack
        mov     ss,cs:sslocal
        mov     sp,cs:splocal
        sti
        push    cs
        pop     ds
        ret
packet  endp

;
;*** Variables ***
;
sslocal dw      ?
splocal dw      ?
        dw      128 dup(?)
sflocal dw      ?

banner  db      32,201,76 dup(205),187,13,10,32,186
        db      19 dup(32)
        db      '   BP-LAN Version 1.00 Server Active  '
        db      19 dup(32)
        db      186,13,10,32,200,76 dup(205),188,13,10,10,0

packet_length   dw      ?
socket_num db   0
buffer_length   dw      512
intnum  equ     28h
new_int proc    far
        pushf
        push    es
        push    bx
        push    ax
        cmp     byte ptr cs:in_28,0
        jnz     new_i4
        mov     byte ptr cs:in_28,1
        pushall
        push    cs
        pop     ds
        mov     cs:socket_num,0
new_i1: call    packet
        inc     socket_num
        bpbios  ctrl_int,get_nodes
        cmp     ah,cs:socket_num
        jg      new_i1
        popall
        mov     byte ptr cs:in_28,0
new_i4:
        pop     ax
        pop     bx
        pop     es
        popf
        jmp     cs:old_int_vector       ;Chain to Previous INT Handler
new_int endp

;*************************************
;*** Install New Interrupt Handler ***
;*************************************
intinst proc    near
        mov     ah,34h
        int     21h
        mov     dos_flag_offs,bx
        mov     dos_flag_seg,es

        mov     ah,35h          ; get interrupt vector function
        mov     al,intnum       ; get interrupt #
        int     21h

        mov     old_int_offs,bx ; save old interrupt
        mov     old_int_seg,es  ;   address

        mov     ah,25h                  ; set interrupt vector function
        mov     al,intnum               ; set interrupt #
        mov     dx,offset new_int       ; point to new routine
        int     21h
        lea     dx,packet_buffer
        add     dx,16
        add     dx,buffer_length
        int     27h
intinst endp

;*** Variables ***
;
dos_flag_offs   dw      ?
dos_flag_seg    dw      ?
old_int_vector  label   dword
old_int_offs    dw      ?
old_int_seg     dw      ?
int_src_vector  label   dword
int_src_offs    dw      ?
int_src_seg     dw      ?
        dw      100     dup(?)
newstack        dw      ?
stackseg        dw      ?
stackoff        dw      ?
in_28   db      0
packet_buffer   db      ?

codeseg ends
        end     init
