;************************************************************
;* Low Level Function Execution Module       (LOWLEVEL.MOD) *
;* by Craig Chaiken                                         *
;* January 30, 1990                                         *
;*                                                          *
;* Function: Executes Low Level Function on Remote PC       *
;************************************************************
;

lowlev  proc    near
        cmp     packet_buffer,'r'
	jnz	lowle1
        jmp     peekmem
lowle1: cmp	packet_buffer,'w'
	jnz	lowle2
	jmp	pokemem
lowle2: cmp	packet_buffer,'i'
	jnz	lowle3
	jmp	portin
lowle3: cmp	packet_buffer,'o'
	jnz	lowle4
	jmp	portout
lowle4: cmp	packet_buffer,'e'
	jnz	lowle5
	jmp	execute
lowle5: cmp	packet_buffer,'f'
	jnz	lowle6
	jmp	fillmem
lowle6: cmp	packet_buffer,'m'
	jnz	lowlev7
	jmp	movemem
lowlev7:ret
lowlev  endp

peekmem proc	near
	pushall
	mov	si,word ptr cs:packet_buffer+1
	mov	es,word ptr cs:packet_buffer+3
	mov	cx,word ptr cs:packet_buffer+5
	mov	di,offset cs:packet_buffer+1
	mov	bx,cx
	inc	bx
	mov	cs:packet_length,bx
	mov	byte ptr cs:packet_buffer,'D'
	call	essitodi
	put_packet	cs:socket_num,cs:packet_length,offset packet_buffer
	popall
        ret
peekmem endp

pokemem proc	near
	pushall
        mov     di,word ptr cs:packet_buffer+1
	mov	es,word ptr cs:packet_buffer+3
	mov	cx,word ptr cs:packet_buffer+5
	mov	si,offset cs:packet_buffer+7
	mov	bx,cx
	inc	bx
	mov	cs:packet_length,bx
	call	sitoesdi
	popall
	ret
pokemem endp

portin	proc	near
	pushall
	mov	dx,word ptr cs:packet_buffer+1
	in	al,dx
	mov	cs:packet_buffer+1,al
	mov	cs:packet_buffer,'D'
	mov	word ptr cs:packet_length,2
	put_packet	cs:socket_num,cs:packet_length,offset packet_buffer
        popall
	ret
portin	endp

portout proc	near
	pushall
	mov	dx,word ptr cs:packet_buffer+1
	mov	al,cs:packet_buffer+3
	out	dx,al
	popall
	ret
portout endp

execute proc	near
	pushall
        call    offset byte ptr cs:packet_buffer+1
	popall
        ret
execute endp

fillmem proc	near
	pushall
	mov	di,word ptr cs:packet_buffer+1
	mov	es,word ptr cs:packet_buffer+3
	mov	cx,word ptr cs:packet_buffer+9
	mov	al,cs:packet_buffer+11
	cld
	rep	stosb
	popall
	ret
fillmem endp

movemem proc	near
	pushall
	mov	si,word ptr cs:packet_buffer+1
	mov	ds,word ptr cs:packet_buffer+3
	mov	di,word ptr cs:packet_buffer+5
	mov	es,word ptr cs:packet_buffer+7
	mov	cx,word ptr cs:packet_buffer+9
	call	sitoesdi
        popall
	ret
movemem endp

;************************************************************
;* End of Low Level Function Execution Module               *
;************************************************************
