@echo off
rem type 'SETX10' to display output to screen
rem type 'SETX10 filename' to redirect output to a log file
echo Ŀ
echo   Starting SETX10 Procedure  
echo 
set LOG=
if (%1)==() goto skplog
echo.>%1
set LOG=>>%1
:skplog
echo .............................................................. %LOG%
echo Initialize the local Lawn & connect to the X10/Lawn %LOG%
rem
rem Use the following line when using XL.EXE
lawn -a,-i,di,co x10 %LOG%
rem
rem Use the following line with any other X10 software
rem lawn -a,-i,di,ab 600,-b600,-c,co x10 %LOG%
rem
if errorlevel 0 goto skperr
echo Error Initializing Lawn - aborting batch file
goto end
:skperr
echo .............................................................. %LOG%
echo Reprogram the X10 using a copy of XA patched to use the serial %LOG%
echo port at the existing settings instead of 600 baud %LOG%
rem
xl f=reset.x10 %LOG%
echo .............................................................. %LOG%
echo Query the X10 for a list of all programmed events %LOG%
rem
xr -s %LOG%
echo. %LOG%
echo .............................................................. %LOG%
echo Disconnect the Lawn-to-Lawn connection %LOG%
rem
rem Use the following line when using XL.EXE
lawn -a,-c,di %LOG%
rem
rem Use the following line with any other X10 software
rem lawn -a,-c,di,ab 19200,-b19200 %LOG%
rem
:end
