Comment
========================================================================

MarxMenu supports several "Look and Feel" options. You can choose from:

NOVELL.INC
BLOCK.INC
GRID.INC

By including different files MarxMenu compiles the same menu with
completely different looks.

Colors are set by editing these include files.

========================================================================
EndComment

;----- Select include file.

Include 'NOVELL.INC'
;Include 'BLOCK.INC'
;Include 'GRID.INC'

;----- Turn this on if you like the Greek Column Look.

Greek On

OnScreenOnly ;limits choices to those on the screen only.
AllowEsc
AllowAbort Off
UseArrows
LookSetup

;================< FEATURE CONTROL AREA >================

;----- WORM.INC loads the example custom screen blanker program

  Include 'WORM.INC'

;----- Set up the blank screen message if you want one.

  BlankMessage = ''

;----- Change BlankTime to 0 if you do not want to blank the screen.

  BlankTime = 5

;----- Change LogoffTime to number of minutes if you want timed Logoff.

  LogoffTime = 0

;----- Use Novell Password or LockWord to unlock the screen blanker.

if NetworkVersion
   if NovConnection <> 0
      UseNovPassword Off    ;change to On to activate this feature
   else
      LockWord = ''
   endif
endif

;----- This makes the menu come back to the same menu level.

  SavePosition On

;----- Control Explode effects.

  Explode On


;========================================================

;----- Support routines for conditional menus

Var
  IndexString

;----- Adds a choice to list

Procedure AddChoice (Prompt,TaskNum)
   IndexString[CurrentWindow + 1] = Left(IndexString[CurrentWindow + 1],NumberOfElements(Choices)) + Char(TaskNum + 64)
   AppendArray(Choices,Prompt)
EndProc

;----- Compares TaskNum to Choice

Procedure Task (TaskNum)
   if Mid(IndexString[CurrentWindow],Ord(LastKey) - 64,1) = Char(TaskNum + 64)
      Return LastKey
   else
      Return ""
   endif
EndProc

